import axios from 'axios'
import { Notify, Dialog  } from 'vant';
import store from 'src/store'
import { getToken } from 'src/utils/auth'
import errorCode from 'src/utils/errorCode'
import { tansParams, blobValidate } from "src/utils/iufc";

axios.defaults.headers['Content-Type'] = 'application/json;charset=utf-8'
// 创建axios实例

//axios.defaults.baseURL='http://192.168.31.139:8094/';

const service = axios.create({
  // axios中请求配置有baseURL选项，表示请求URL公共部分
    baseURL: localStorage.getItem('cloudServerAddress') + '/sub-api' || process.env.VUE_APP_BASE_API + '/sub-api' ,
  // 超时
  timeout: 20000,
  // withCredentials: false, // default
  // httpsAgent: new https.Agent({// 忽略 SSL 的属性
  //   rejectUnauthorized: true,
  //   keepAlive: true
  // })
})

// request拦截器
service.interceptors.request.use(config => {
  // 是否需要设置 token
  const isToken = (config.headers || {}).isToken === false
  if (getToken() && !isToken) {
    config.headers['Authorization'] = 'Bearer ' + getToken() // 让每个请求携带自定义token 请根据实际情况自行修改
  }
  // console.log("当前token:" + config.headers['Authorization'])
  // get请求映射params参数
  if (config.method === 'get' && config.params) {
    let url = config.url + '?' + tansParams(config.params);
    url = url.slice(0, -1);
    config.params = {};
    config.url = url;
  }
  return config
}, error => {
    console.log(error)
    Promise.reject(error)
})

// 响应拦截器
service.interceptors.response.use(res => {
    // 未设置状态码则默认成功状态
    const code = res.data.code || 200;
    // 获取错误信息
    const msg = errorCode[code] || res.data.msg || errorCode['default']
    // 二进制数据则直接返回
    if(res.request.responseType ===  'blob' || res.request.responseType ===  'arraybuffer'){
      return res.data
    }
    if (code === 401) {
      Dialog.confirm({
        title: '系统提示',
        message: '登录状态已过期，您可以继续留在该页面，或者重新登录',
      }).then(() => {
        store.dispatch('LogOut').then(() => {
          location.href = '/login';
        })
      }).catch(() => {});
      return Promise.reject('无效的会话，或者会话已过期，请重新登录。')
    } else if (code === 500) {
      Notify({ type: 'danger', message: msg });
      return res.data
    } else if (code !== 200) {
      Notify({ type: 'danger', message: msg });
      return Promise.reject('error')
    } else {
      return res.data
    }
  },
  error => {
    console.log('err' + error)
    let { message } = error;
    if (message == "Network Error") {
      message = "后端接口连接异常";
    }
    else if (message.includes("timeout")) {
      message = "系统接口请求超时";
    }
    else if (message.includes("Request failed with status code")) {
      message = "系统接口" + message.substr(message.length - 3) + "异常";
    }
    Notify({ type: 'danger', message: message, duration: 5 * 1000 });

    return Promise.reject(error)
  }
)

export default service
